package Active;

/**
 * Prime Sieve using active objects -- each prime in the
 * sieve has its own thread.
 * @author Oscar Nierstrasz
 * @see ActivePrime
**/

public class PrimeSieve {

	/**
	 * @param args number of primes to generate
	**/

	public static void main(String args[]) {
		System.out.println("Prime Sieve starting ...");

		if (args.length > 0) {
			try {
				int n = Integer.parseInt(args[0]);
				genPrimes(n);
			} catch (NumberFormatException e) {
				System.out.println("Error: " + args[0] + " not a number");
			}
		} else {
			int n = 2000;
			System.out.println("Running genPrimes(" + n + ")");
			genPrimes(n);
		}
	}

	public static void genPrimes(int n) {
		try {
			ActivePrime firstPrime = new ActivePrime(2, new TestForPrime(n));
		} catch (Exception e) {
			System.err.println(e.getMessage());
		}	
	}
}
