package Counter;

/**
* Illustrates encapsulation of assignment.
*/
public class BoundedCounterV1  extends BoundedCounterV0 {
	
	public synchronized void inc() {
		awaitIncrementable();
		setCount(count_ + 1);
	}
	
	public synchronized void dec() {
		awaitDecrementable();
		setCount(count_ - 1);
	}
	
	protected synchronized void awaitIncrementable() {
		while (count_ >= MAX)
			try { wait(); }
			catch(InterruptedException ex) { };
	}

	protected synchronized void awaitDecrementable() {
		while (count_ <= MIN)
			try { wait(); }
			catch(InterruptedException ex) { };
	}

	protected synchronized void setCount(long newValue) {
		count_ = newValue;
		notifyAll();
	}
}
