//@author: j.n.magee 11/11/96
//adapted  acherman
package golf;

import java.awt.*;
import java.applet.*;

/**
 *  Wrapper Class to visualize the state of an Allocator
 */
class DisplayAllocator extends Panel implements IAllocator 
{
	public final static Font TEXT_FONT = new Font("Helvetica",Font.BOLD,36);
	public final static Font TITLE_FONT = new Font("Times",Font.ITALIC+Font.BOLD,24);

	final Label contents_; 
	final Label title_; 

	final IAllocator alloc_;
	private int hiredout_  =  0;
	private int available_;

	DisplayAllocator( IAllocator a ) 
	{
		super(new BorderLayout());

		alloc_  =  a;
		available_ = getCapacity();

		title_ = new Label(alloc_.getTitle(), Label.CENTER); 
		title_.setFont(TITLE_FONT); 
		contents_ = new Label("", Label.CENTER); 
		contents_.setFont(TEXT_FONT); 
		add(title_, BorderLayout.NORTH); 
		add(contents_, BorderLayout.CENTER); 
		display(); 
	}

	private void display() 
	{
		contents_.setText( "available =  " + String.valueOf( available_ )
						+ "  hired out =  " + String.valueOf( hiredout_ ) );
	}

	/** required for IAllocator
	 */
	public void get( int n ) throws InterruptedException 
	{
		 alloc_.get( n );
		 synchronized ( this ) 
		 {
			 available_ -= n;
			 hiredout_ += n;
		 }
		 display();
	}

	/** required for IAllocator
	 */
	public void put( int n ) 
	{
		 alloc_.put( n );
		 synchronized ( this ) 
		 {
			 hiredout_ -= n;
			 available_ += n;
		 }
		 display();
	}


	public int getCapacity() 
	{
		return alloc_.getCapacity(); 
	}


	public String getTitle() {
		return title_.getText(); 
	}
 }

