/*
  File: SafeReadWrite.java
*/

package readwrite;

public class SafeReadWrite implements ReadWrite 
{

	int readers_ = 0;
	
	boolean writing_ = false;

	ReaderWriterPanel view_;

	public SafeReadWrite( ReaderWriterPanel view )
	{
		view_ = view;
	}

	public synchronized void acquireRead() throws InterruptedException 
	{
		while ( writing_ ) 
			wait();
		readers_++;
		view_.setReader( readers_ );
	}

	public synchronized void releaseRead() 
	{
		readers_--;
		view_.setReader( readers_ );
		if ( readers_ == 0 ) 
			notifyAll();
	}

	public synchronized void acquireWrite() throws InterruptedException 
	{
		while ( readers_ > 0 || writing_ ) 
			wait();
		writing_ = true;
		view_.setWriter();
	}

	public synchronized void releaseWrite() 
	{
		writing_ = false;
		view_.clearWriter();
		notifyAll();
	}

}
