/**
* FairAllocator Class
*
* First-come, first-serve using tickets.
*/
package golf;

public class FairAllocator extends SimpleAllocator
{
	protected int counter_ = 0;
	protected int nowServing_ = 0;

	public FairAllocator(int n) 
	{ 
		super(n);
	}

	synchronized public void get(int n) throws InterruptedException 
	{
		int ticket = getTicket();
		while ( !myTurn(ticket) || n > available_ ) 
			wait();
		available_ -= n;
		leave();
	}

	protected int getTicket() {
		return counter_++;
	}

	protected boolean myTurn(int ticket) {
		return ticket == nowServing_;
	}

	protected void leave() {
		nowServing_++;
		notifyAll();
	}

	public String getTitle() 
	{
		return "FairAllocator"; 
	} 

 }
