/*
  File: FairReadWrite.java
*/

package readwrite;

public class FairReadWrite extends WritersPriorityReadWrite implements ReadWrite 
{

	boolean writersPriority_ = true;

	public FairReadWrite( ReaderWriterPanel view )
	{
		super(view);
	}

	public synchronized void acquireRead() throws InterruptedException 
	{
		while ( (waitingWriters_ > 0 && writersPriority_) || writing_ ) 
			wait();
		readers_++;
		view_.setReader( readers_ );
	}

	public synchronized void releaseRead() 
	{
	writersPriority_ = true;
		super.releaseRead() ;
	}

	public synchronized void releaseWrite() 
	{
	writersPriority_ = false;
	super.releaseWrite() ;
	}

}
