/*
  File: ReadersWriters.java
*/

package readwrite;

import java.awt.*;
import java.applet.*;
import support.*;

public class ReadersWriters extends Applet 
{

	RotatingPanel read1_;

	RotatingPanel read2_;

	RotatingPanel write1_;

	RotatingPanel write2_;

	ReadWrite readerwriter_;

	ReaderWriterPanel view_;

	/** hook factory method to instantiate policy
	 */
	protected ReadWrite makePolicy( ReaderWriterPanel view ) 
	{
		return new SafeReadWrite( view ); 
	}

	public void init() 
	{
		setLayout( new BorderLayout() );

		view_ = new ReaderWriterPanel();
		add( view_, BorderLayout.NORTH );
		readerwriter_ = makePolicy( view_ );  

		Panel p = new Panel();
		read1_ = new RotatingPanel( "Reader 1", null,
									new Reader( readerwriter_ ) );
		read2_ = new RotatingPanel( "Reader 2", null, 
									new Reader( readerwriter_ ) );
		write1_ = new RotatingPanel( "Writer 1", null,
									 new Writer( readerwriter_ ) );
		write1_.setRotatorColor( Color.yellow );
		write2_ = new RotatingPanel( "Writer 2", null,
									 new Writer( readerwriter_ ) );
		write2_.setRotatorColor( Color.yellow );
		p.add( read1_ );
		p.add( read2_ );
		p.add( write1_ );
		p.add( write2_ );
		add( p, BorderLayout.CENTER );
	}

	public void start() 
	{
		read1_.start();
		read2_.start();
		write1_.start();
		write2_.start();
	}

	public void stop() 
	{
		read1_.stop();
		read2_.stop();
		write1_.stop();
		write2_.stop();
	 }

}

